import java.awt.*;
import javax.swing.*;
import java.util.*;

public class RMCrpc implements Runnable{

    private JTextField status;
    private JTextArea resultText;
    private JScrollPane sp;
    private String WebserverDest;
    private boolean debug;

  public RMCrpc(JTextField status, JTextArea resultText,
                   JScrollPane sp, String WebserverDest, boolean debug) {

    this.status = status;
    this.resultText = resultText;
    this.sp = sp;
    this.WebserverDest = WebserverDest;
    this.debug = debug;
    if(debug) System.out.println("RMCrpc constructor completed");
  }

    public void run(){

      /* then run the job */
      status.setText("running...delete");
      DeleteFiles(WebserverDest);
      status.setText("completed... delete");

    }

    public void DeleteFiles(String dest)  {
	
	int the_num_of_file = 0;

	while (Connection.remote.exists(dest+"infile_Movie"))  
	    Connection.remote.delete(dest+"infile_Movie");
	if(debug) System.out.println("infile_Movie is deleted...");
	resultText.append("infile_Movie is deleted\n");

	while (Connection.remote.exists(dest+"velTime")) {
	    the_num_of_file = getReadBlockandFileCount("velTime");
	    Connection.remote.delete(dest+"velTime");
	}
	if(debug) System.out.println("velTime is deleted...");
	resultText.append("velTime is deleted\n");
	resultText.append("Total number of the vel* files: "+the_num_of_file+"\n");

	String rm_vel;
	status.setText("vel file Deleting ...");

	for (int i = 0; i < the_num_of_file; i++) {
				
	    if ( i >= 0 && i < 10 ) rm_vel = "vel.00" + i + ".plt" ;
	    else if ( i >= 10 && i < 100) rm_vel = "vel.0" + i + ".plt";
	    else rm_vel = "vel."+ i + ".plt";

	    while (Connection.remote.exists(dest+rm_vel))
		Connection.remote.delete(dest+rm_vel);

	    resultText.append(rm_vel+"...deleted\n");
	    if(debug) System.out.println(rm_vel+"...deleted");
		
	}  //for i=0

	while (Connection.remote.exists(dest+"presTime")) {  
	    the_num_of_file = getReadBlockandFileCount("presTime");
	    Connection.remote.delete(dest+"presTime");
	}
	if(debug) System.out.println("presTime is deleted...");
	resultText.append("presTime is deleted\n");	
	resultText.append("Total number of the pres* files: "+the_num_of_file+"\n");
	
	String rm_pres;
	status.setText("pres file Deleting...");

	for (int i = 0; i < the_num_of_file; i++) {
		
	    if ( i >= 0 && i < 10 ) rm_pres = "pres.00" + i + ".plt" ;
	    else if ( i >= 10 && i < 100) rm_pres = "pres.0" + i + ".plt";
	    else rm_pres = "pres."+ i + ".plt";

	    while (Connection.remote.exists(dest+rm_pres))
		Connection.remote.delete(dest+rm_pres);		

	    resultText.append(rm_pres+"...deleted\n");
	    if(debug) System.out.println(rm_pres+"...deleted");


	}  //for i=0


	while (Connection.remote.exists(dest+"concTime")) {
	    the_num_of_file = getReadBlockandFileCount("concTime");
	    Connection.remote.delete(dest+"concTime");
	}
	if(debug) System.out.println("concTime is deleted...");
	resultText.append("concTime is deleted\n");	
	resultText.append("Total number of the conc* files: "+the_num_of_file+"\n");
	
	String rm_conc1, rm_conc11, rm_conc21;
	status.setText("conc file Deleting...");

	for (int i = 0; i < the_num_of_file; i++) {
		
	    if ( i >= 0 && i < 10 ) {
		rm_conc1 = "conc1-10.00" + i + ".plt" ;
		rm_conc11 = "conc11-20.00" + i + ".plt";
		rm_conc21 = "conc21-27.00" + i + ".plt"; }
	    
	    else if ( i >= 10 && i < 100) { 
		rm_conc1 = "conc1-10.0" + i + ".plt";
		rm_conc11 = "conc11-20.0" + i + ".plt";
		rm_conc21 = "conc21-27.0" + i + ".plt"; }
	    
	    else {  
		rm_conc1 = "conc1-10."+ i + ".plt";
		rm_conc11 = "conc11-20." + i + ".plt";
		rm_conc21 = "conc21-27." + i + ".plt";  }

	    while (Connection.remote.exists(dest+rm_conc1))
		Connection.remote.delete(dest+rm_conc1);

	    resultText.append(rm_conc1+"...deleted\n");
	    if(debug) System.out.println(rm_conc1+"...deleted");

	    
	    while (Connection.remote.exists(dest+rm_conc11))
		Connection.remote.delete(dest+rm_conc11);

	    resultText.append(rm_conc11+"...deleted\n");
	    if(debug) System.out.println(rm_conc11+"...deleted");

	    while (Connection.remote.exists(dest+rm_conc21))
		Connection.remote.delete(dest+rm_conc21);

	    resultText.append(rm_conc21+"...deleted\n");
	    if(debug) System.out.println(rm_conc21+"...deleted");

	}  //for i=0
    }
    
    public int getReadBlockandFileCount(String filename) {
  
	String file_context = null;
	String file_context1 = null;
	byte[] file_read = null;
	int    read_block_num = 0;
	int    blocksize = 1024;
	int    filesize = 0;
	int    file_count = 0;

	try {

	    Connection.remote.open(WebserverDest+filename, "r");
	    filesize = Connection.remote.getFileSize();
	    
	    if ( filesize <= blocksize ) {
		file_read = Connection.remote.getBlock();
		file_context = new String(file_read);   }
	    else {
		read_block_num = filesize / blocksize;
		if ( (filesize % blocksize) > 0 ) read_block_num = read_block_num + 1;
		file_read = Connection.remote.getBlock();
		file_context = new String(file_read);
		
		for ( int i=1; i < read_block_num; i++) {		
		    file_read = Connection.remote.getBlock();
		    file_context1 = new String(file_read);
		    file_context = file_context.concat(file_context1); } 
	    }
	    Connection.remote.close();

	    StringTokenizer st = new StringTokenizer(file_context);
	    while (st.hasMoreTokens()) {
		st.nextToken();
		st.nextToken();
		file_count = file_count + 1; 
	    }

	    if(debug) System.out.println("FILE size: "+filesize);
	    if (debug) System.out.println("Reading veltime: "+file_context);
	    
	} catch(WebFlow.RemoteFile2.RemoteFile2Package.FileException ex)
	    {
		if (debug) { System.out.println("Can't read from `" +
						ex.getMessage() + "'");
		System.exit(1); }
	    } catch (WebFlow.RemoteFile2.RemoteFile2Package.EOFFileException ex1) {
		if (debug) { System.out.println("Can't read from `" +
						ex1.getMessage() + "'");
		System.exit(1); }
	    }
	
	return file_count;
    }


    public synchronized void waitFor(long howLong){
	try {
	    wait(howLong);
	} catch (Exception e) { System.out.println(e);}
    }
}




